;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;           Kaleidoscope
;                By
;         Scott H. McGurrin
;         Syntax v5,n01 p.19
;================================

ORG 4084

@DFile=400C
@Frames=4034
@Keyboard=02BB

@Start
	LD HL,(Frames)     	;Pointer to ROM HL=0 to 65535
@Reset
        RES 5,H          	;Trim off excess bits
        RES 6,H
        RES 7,H            	;HL=0 to 8192
@Vals    
	LD B,(HL)          	;Random Y value
        INC HL
        RES 6,B
        RES 7,B            	;B=0 to 63
        LD A,2F            	;B>47?
        CP B
        JR C Vals          	;Yes, go back too high
        LD C,(HL)          	;Random X value
        INC HL
        RES 6,C
        RES 7,C            	;C=0 to 63
        LD A,(HL)		;Random Plot/Unplot choice
        INC HL			
        BIT 0,A            	;Plot or UnPlot pixels
        JR NZ NoPlot
        LD A,40            	;40 FOR Plot
        JR DoPlot
@NoPlot
	XOR A              	;0 FOR UNPlot
@DoPlot  
	PUSH AF		   	;PUSH Plot/UnPlot Flag
	CALL Plot		;PLOT X,Y
        LD A,2F			;47
        SUB B
        LD B,A
	POP AF 		   	;POP Plot/UnPlot Flag
	PUSH AF		   	;PUSH Plot/UnPlot Flag
	CALL Plot		;PLOT X,47-Y
        LD A,3F			;63
        SUB C
        LD C,A
	POP AF		   	;POP Plot/UnPlot Flag
	PUSH AF		   	;PUSH Plot/UnPlot Flag
	CALL Plot		;PLOT 63-X,47-Y
        LD A,2F			;47
        SUB B
        LD B,A
	POP AF		 	;POP Plot/UnPlot Flag
	CALL Plot		;PLOT 63-X,Y
	PUSH HL
        CALL Keyboard		;Test for keypress
        INC H
        POP HL
        JR Z Reset
        RET
;================================
;Plot Routine, full screen 
;Plot/UNPlot statements.
;Modified from...
;
;Um Plot Rpido (RAPID Plot)
;"Usando Linguagem De Mquina" 
;by Mario Schaeffer
;================================
@Plot
	PUSH BC			;PUSH X,Y coords
        PUSH HL			;PUSH ROM random pointer
@Plot01				;Is Y an ODD or EVEN row?
	PUSH AF			;PUSH Plot/UnPlot flag
	LD A,87			;A=87=NW Pixel
	BIT 0,B			;Y coord
	JR NZ Plot02		;ODD line number?
	ADD A,10		;A=97=SW Pixel 
@Plot02				;Is X ODD or EVEN column?		
	BIT 0,C			;X coord
	JR Z Plot03		;EVEN col number?
	ADD A,08		;A=8F=NE Pixel or A=9F=SE Pixel
@Plot03
	LD D,A			;D=Pixel quadrant value
	POP AF			;POP Plot/UnPlot flag
	ADD A,D			;A=D IF UNPlot or D+64 IF Plot
	LD (PlotPX+1),A		;Self modifying code
	SRL B			;Convert Y-coord to Print coord, Y/2
	SRL C			;Convert X-coord to Print coord, X/2
	LD HL,(DFile)
	INC HL
	LD D,00
	LD E,C			;DE=Column number
	ADD HL,DE		;HL=Column position in DFile
	LD A,17			;23-Y/2
	SUB B
	LD B,A			;B=Row number
	JR Z Plot05
	LD DE,21
@Plot04
	ADD HL,DE
	DJNZ Plot04
@Plot05
	LD A,(HL)
	CP 08			;LO Pixel Chr
	JR C PlotPX
	CPL			;HI Pixel Chr
@PlotPX	
	SET 00,A		;00=SR SET/RES X,A
	BIT 3,A
	JR Z LOWPX
	CPL
	AND 8F
	JR HIPX
@LOWPX				;Low value PIXEL, codes 1 to 7
	AND 0F
@HIPX				;Hi value PIXEL, codes 128 to 135
	LD (HL),A
        POP HL			;POP ROM random pointer
	POP BC			;POP X,Y coords
	RET