;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;           Kaleidoscope
;                By
;         Scott H. McGurrin
;         Syntax v5,n01 p.19
;================================

ORG 4084

@DFile=400C
@TAddr=4030
@Frames=4034
@Keyboard=02BB
@PlotBC=0BB2
@CLS=0A2A

	"KALEIDOSCOPEPRESS ANY KEY TO BEGIN"
@Print
	LD HL,(DFile)
        LD BC,00D0
        ADD HL,BC
        EX DE,HL
        LD HL,4084        ;Print message on screen
        LD BC,000C
        LDIR
        EX DE,HL
        LD BC,0119
        ADD HL,BC
        EX DE,HL
        LD BC,0016
        LDIR
@Pause   
	LD DE,C800        ;Timing loop
@PLoop
	DEC DE
        LD A,D
        OR E
        JR NZ PLoop
@Disp    
	LD A,I             ;Display scrambling routine
        INC A
        LD I,A
        CALL Keyboard      ;Key Press?
        INC H
        JR Z Disp
@Fix     
        LD A,1E            ;Return to normal display
        LD I,A
        CALL CLS           ;Clear screen
@Wait    
        CALL Keyboard      ;Wait until no key
        INC H
        JR NZ Wait
        LD HL,(Frames)     ;Pointer to ROM HL=0 to 65535
@Reset
;[***** Added RES 5,H to limit range to 0 to 8192, GCH *****]
        RES 5,H            ;Trim off excess bits
        RES 6,H
        RES 7,H            ;HL=0 to 8191
@Vals    
	LD B,(HL)          ;Random Y value
        INC HL
        RES 6,B
        RES 7,B            ;B=0 to 63
        LD A,2B            ;B>43?
        CP B
        JR C Vals          ;Yes, go back too high
        LD C,(HL)          ;Random X value
        INC HL
        RES 6,C
        RES 7,C            ;C=0 to 63
        LD A,(HL)
        INC HL
        BIT 0,A            ;Plot or Unplot pixels
        JR NZ UNPlot
        XOR A              ;O FOR Plot
        JR Doplot
@Unplot  
	LD A,80            ;128 FOR UNPlot
@Doplot  
	PUSH AF		   ;PUSH Plot/Unplot Flag
@Plot1   
	CALL Plot
        LD A,2B
        SUB B
        LD B,A
        POP AF             ;POP Plot/Unplot Flag
        PUSH AF		   ;PUSH Plot/Unplot Flag
@Plot2   
	CALL Plot
        LD A,3F
        SUB C
        LD C,A
;[***** Error in Listing, GCH *****]
;       PUSH AF
;       POP AF
;===================================
        POP AF             ;POP Plot/Unplot Flag
        PUSH AF		   ;PUSH Plot/Unplot Flag
@Plot3   
	CALL Plot
        LD A,2B
        SUB B
        LD B,A
        POP AF             ;POP Plot/Unplot Flag
@Plot4   
	CALL Plot
@Copy    
	PUSH HL
        CALL Keyboard
        INC H
        POP HL
        JR Z Reset
        RET
@Plot    
	PUSH BC
        PUSH HL
        LD (TAddr),A
        CALL PlotBC
        POP HL
        POP BC
        RET